import kareltherobot.*;

public class LeftTurnDecorator implements Strategy
{
	public LeftTurnDecorator(Strategy decorated)
	{
		myDecorated = decorated;
	}

	public void doIt(UrRobot aRobot)
	{
		aRobot.turnLeft();
		myDecorated.doIt(aRobot);
	}

	private Strategy myDecorated = null;
}
