import kareltherobot.*;

public class Mathematician extends AugmentedRobot
{

	public Mathematician(int street, int avenue, Direction direction, int beepers)
	{	super(street, avenue, direction, beepers);
	}
	
	public void zigLeftUp () 
	{	// Precondition: facingWest and frontIsClear
		// Postcondition: facingWest
		move();
		turnRight();
		move();
		turnLeft();
	}

	public void zagDownRight() 
	{	// Precondition: facingSouth and frontIsClear
		// Postcondition: facingSouth 
		move();
		turnLeft();
		move();
		turnRight();
	}
		
	public void  findBeeper() 
	{	goToOrigin();
		faceWest();
		while (  ! nextToABeeper() ) 
		{	if ( facingWest() ) 
			{	zigMove();
			}
			else 
			{	zagMove();
			}
		}
	}
	
	public void goToOrigin()
	{	// pre: no blocking walls
		faceWest();
		goToWall();
		turnLeft();
		goToWall();
	}
	
	public void goToWall()
	{
		while(frontIsClear())
		{	
			move();
		}
	}

	public void  zigMove() 
	{	// Pre-condition: facingWest
		if ( frontIsClear() ) 
		{	zigLeftUp ();
		}
		else 
		{	advanceToNextDiagonal();
		}
	}
	
	public void  zagMove() 
	{	// Pre-condition: facingSouth()
		if ( frontIsClear() ) 
		{	zagDownRight();
		}
		else 
		{	advanceToNextDiagonal();
		}
	}
	
	public void  advanceToNextDiagonal() 
	{	if ( facingWest() ) 
		{	faceNorth();
		}
		else 
		{	faceEast();
		}
		move();
		turnAround();
	}


}
