import kareltherobot.*;


public class Choreographer extends UrRobot
{	
	public Choreographer(int street, int avenue, Direction direction, int beepers)
	{	super(street, avenue, direction, beepers);
	}
	
	private UrRobot lisa = new UrRobot(4,2,East,0);  	
		// the first helper robot
	private UrRobot tony = new UrRobot(6,2,East,0);	
		// the second helper robot


	public void harvest()
	{
		harvestARow();
		turnLeft();
		move();
		turnLeft();
		harvestARow();
	}

	public void harvestARow()
	{	move();
		harvestCorner();
		move();
		harvestCorner();
		move();
		harvestCorner();
		move();
		harvestCorner();
		move();
		harvestCorner();
		move();
	}

	public void harvestCorner()
	{
		pickBeeper();
	}


	public void  move()
	{	super.move();
		lisa.move();
		tony.move();
	}
	
	public void  turnLeft()
	{	super.turnLeft();
		lisa.turnLeft();
		tony.turnLeft();
	}


	public void  turnOff()
	{	super.turnOff();
		lisa.turnOff();
		tony.turnOff();
	}
	
	public void  pickBeeper()
	{	super.pickBeeper();
		lisa.pickBeeper();
		tony.pickBeeper();
	}
	
	public void  putBeeper()
	{	super.putBeeper();
		lisa.putBeeper();
		tony.putBeeper();
	}
}

